package com.dbxml.xml;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: QName.java,v 1.2 2004/02/12 00:17:58 bradford Exp $
 */

/**
 * QName represents an XML qualified name.
 */

public final class QName {
   private String name;
   private String uri;

   public QName(String name, String uri) {
      this.name = name;
      if ( uri != null && uri.length() > 0 )
         this.uri = uri;
      else
         this.uri = null;
   }

   public QName(String name) {
      this.name = name;
   }

   public String getName() {
      return name;
   }

   public String getPrefix() {
      int idx = name.indexOf(':');
      if ( idx != -1 )
         return name.substring(0, idx);
      else
         return null;
   }

   public String getSAXPrefix() {
      String prefix = getPrefix();
		if ( prefix != null )
			return prefix;
		else
			return "";
   }

   public String getLocalName() {
      int idx = name.indexOf(':');
      if ( idx != -1 )
         return name.substring(idx + 1);
      else
         return name;
   }

   public String getURI() {
      return uri;
   }

   public String getSAXURI() {
		if ( uri != null )
			return uri;
		else
			return "";
   }

   public boolean isNamespaceDecl() {
      if ( name.startsWith("xmlns") )
         return name.length() == 5 || name.charAt(5) == ':';
      else
         return false;
   }
}
